// IconStatic.cpp
//

#include "stdafx.h"
#include "IconStatic.h"
#include "atlconv.h"

#ifdef THEMEAPI
#include <tmschema.h>
#else
#define	NO_THEMEAPI_FOUND

#define	BP_PUSHBUTTON	0x00000001
#define	PBS_NORMAL	0x00000001
#define	PBS_HOT		0x00000002
#define	PBS_PRESSED	0x00000003
#define	PBS_DISABLED	0x00000004
#define	PBS_DEFAULTED	0x00000005
#endif

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CIconStatic

CIconStatic::CIconStatic()
{
	m_pTheme = NULL;
	m_nIconID = 0;
}

CIconStatic::~CIconStatic()
{
	if(m_MemBMP.GetSafeHandle())
		m_MemBMP.DeleteObject();
}

BEGIN_MESSAGE_MAP(CIconStatic, CStatic)
	//{{AFX_MSG_MAP(CIconStatic)
		ON_WM_SYSCOLORCHANGE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
void CIconStatic::Init(UINT nIconID, CThemeHelperST *pTheme)
{
	USES_CONVERSION; // FoRcHa

	m_nIconID = nIconID;
	m_pTheme = pTheme;

// If this function is called for the first time and we did not yet call 'SetWindowText', we take
// take the window label which is already specified for the window (the label which comes from the resource)
	CString strText;
	GetWindowText(strText);
	SetWindowText(_T(""));
	if (!strText.IsEmpty() && m_strText.IsEmpty())
		m_strText = strText;

	CRect rRect;
	GetClientRect(rRect);

	CDC *pDC = GetDC();
	CDC MemDC;
	CBitmap *pOldBMP;
	MemDC.CreateCompatibleDC(pDC);

	CFont *pOldFont = MemDC.SelectObject(GetFont());

	CRect rCaption(0,0,0,0);
	MemDC.DrawText(m_strText, rCaption, DT_CALCRECT);
	if (rCaption.Height() < 16)
		rCaption.bottom = rCaption.top + 16;
	rCaption.right += 25;
	if (rCaption.Width() > rRect.Width() - 16)
		rCaption.right = rCaption.left + rRect.Width() - 16;

	if (m_MemBMP.GetSafeHandle())
		m_MemBMP.DeleteObject();
	m_MemBMP.CreateCompatibleBitmap(pDC, rCaption.Width(), rCaption.Height());
	pOldBMP = MemDC.SelectObject(&m_MemBMP);

	MemDC.FillSolidRect(rCaption, GetSysColor(COLOR_BTNFACE));
	HICON hIcon = (HICON)::LoadImage(AfxGetInstanceHandle(), MAKEINTRESOURCE(m_nIconID), IMAGE_ICON, 16,16, 0);
	DrawState(MemDC.m_hDC, NULL, NULL, (LPARAM)hIcon, NULL, 3, 0, 16, 16, DST_ICON | DSS_NORMAL);
	DestroyIcon(hIcon);
	rCaption.left += 22;

///////////////////////////////////

	BOOL bDefaultDraw = FALSE;
	if(m_pTheme == NULL || m_pTheme->IsAppThemed() == FALSE)
	{
		bDefaultDraw = TRUE;
	}
	else
	{
		HTHEME	hTheme;

		if((hTheme = m_pTheme->OpenThemeData(GetSafeHwnd(), L"BUTTON")) != 0)
		{
/*
		BSTR str = A2WBSTR(m_strText); // FoRcHa
		m_pTheme->DrawThemeText(hTheme, MemDC.m_hDC, 4, 1, str, 
			m_strText.GetLength(), DT_WORDBREAK | DT_CENTER | DT_WORD_ELLIPSIS, 
			NULL, &rCaption);
		m_pTheme->CloseThemeData(hTheme);
		SysFreeString(str); // FoRcHa
*/
			LPOLESTR oleText = CT2OLE(m_strText);
			m_pTheme->DrawThemeText(hTheme, MemDC.m_hDC, 4, 1, oleText, ocslen (oleText),
				DT_WORDBREAK | DT_CENTER | DT_WORD_ELLIPSIS, NULL, &rCaption);
		}
		else
		{
			bDefaultDraw = TRUE;
		}
	}

	if (bDefaultDraw)
	{
		MemDC.SetTextColor(pDC->GetTextColor());
		MemDC.DrawText(m_strText, rCaption, DT_SINGLELINE | DT_LEFT | DT_END_ELLIPSIS);
	}

	MemDC.SelectObject(pOldBMP);
	MemDC.SelectObject(pOldFont);

	if (m_wndPicture.m_hWnd == NULL)
		m_wndPicture.Create(NULL, WS_CHILD | WS_VISIBLE | SS_BITMAP, CRect(0,0,0,0), this);
	m_wndPicture.SetWindowPos(NULL, rRect.left+8, rRect.top, rCaption.Width()+22, rCaption.Height(), SWP_SHOWWINDOW);
	m_wndPicture.SetBitmap(m_MemBMP);

	CWnd *pParent = GetParent();
	if (pParent == NULL)
		pParent = GetDesktopWindow();

	CRect r;
	GetWindowRect(r);
	r.bottom = r.top + 20;
	GetParent()->ScreenToClient(&r);
	GetParent()->RedrawWindow(r);

	ReleaseDC(pDC);
}

void CIconStatic::SetText(const CString &strText)
{
	m_strText = strText;
	Init(m_nIconID, m_pTheme);
}

void CIconStatic::OnSysColorChange()
{
	CStatic::OnSysColorChange();
	Init(m_nIconID, m_pTheme);
}
