#include "stdafx.h"
#include "emule.h"
#include "otherfunctions.h"
#include "PPgSMTP.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

IMPLEMENT_DYNAMIC(CPPgSMTP, CPropertyPage)
CPPgSMTP::CPPgSMTP()
	: CPropertyPage(CPPgSMTP::IDD)
{
}

CPPgSMTP::~CPPgSMTP()
{
}

void CPPgSMTP::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_SMTPSERVER, m_strSMTPServer);
	DDX_Text(pDX, IDC_SMTPNAME, m_strSMTPName);
	DDX_Text(pDX, IDC_SMTPFROM, m_strSMTPFrom);
	DDX_Text(pDX, IDC_SMTPTO, m_strSMTPTo);
	DDX_Text(pDX, IDC_SMTPUSERNAME, m_strSMTPUserName);
	DDX_Text(pDX, IDC_SMTPPASSWORD, m_strSMTPPassword);
	DDX_Check(pDX, IDC_SMTPAUTHENTICATED, m_bSMTPAuthenticated);
	DDX_Check(pDX, IDC_SMTPINFOENABLED, m_bSMTPInfoEnabled);
	DDX_Check(pDX, IDC_SMTPWARNINGENABLED, m_bSMTPWarningEnabled);
	DDX_Check(pDX, IDC_SMTPMSGINSUBJECT, m_bSMTPMsgInSubjEnabled);
	DDX_Control(pDX, IDC_SMTPSERVER, SMTPServerEdit);
	DDX_Control(pDX, IDC_SMTPNAME, SMTPNameEdit);
	DDX_Control(pDX, IDC_SMTPFROM, SMTPFromEdit);
	DDX_Control(pDX, IDC_SMTPTO, SMTPToEdit);
	DDX_Control(pDX, IDC_SMTPUSERNAME, SMTPUserNameEdit);
	DDX_Control(pDX, IDC_SMTPPASSWORD, SMTPPasswordEdit);
	DDX_Control(pDX, IDC_SMTPAUTHENTICATED, SMTPAuthenticatedCheck);
	DDX_Control(pDX, IDC_SMTPINFOENABLED, SMTPInfoEnabledCheck);
	DDX_Control(pDX, IDC_SMTPWARNINGENABLED, SMTPWarningEnabledCheck);
	DDX_Control(pDX, IDC_SMTPMSGINSUBJECT, SMTPMsgInSubjectCheck);
	DDX_Text(pDX, IDC_SMTPSERVER_LBL, m_strSMTPServerDesc);
	DDX_Text(pDX, IDC_SMTPNAME_LBL, m_strSMTPNameDesc);
	DDX_Text(pDX, IDC_SMTPFROM_LBL, m_strSMTPFromDesc);
	DDX_Text(pDX, IDC_SMTPTO_LBL, m_strSMTPToDesc);
	DDX_Text(pDX, IDC_SMTPUSERNAME_LBL, m_strSMTPUserNameDesc);
	DDX_Text(pDX, IDC_SMTPPASSWORD_LBL, m_strSMTPPasswordDesc);
	DDX_Text(pDX, IDC_SMTPAUTHENTICATION_FRM, m_strSMTPAuthenticationFrame);
}

BEGIN_MESSAGE_MAP(CPPgSMTP, CPropertyPage)
	ON_EN_CHANGE(IDC_SMTPSERVER, OnDataChange)
	ON_EN_CHANGE(IDC_SMTPNAME, OnDataChange)
	ON_EN_CHANGE(IDC_SMTPFROM, OnDataChange)
	ON_EN_CHANGE(IDC_SMTPTO, OnDataChange)
	ON_EN_CHANGE(IDC_SMTPUSERNAME, OnDataChange)
	ON_EN_CHANGE(IDC_SMTPPASSWORD, OnDataChange)
	ON_BN_CLICKED(IDC_SMTPAUTHENTICATED, OnEnChangeSMTPAuthenticated)
	ON_BN_CLICKED(IDC_SMTPINFOENABLED, OnDataChange)
	ON_BN_CLICKED(IDC_SMTPWARNINGENABLED, OnDataChange)
	ON_BN_CLICKED(IDC_SMTPMSGINSUBJECT, OnDataChange)
END_MESSAGE_MAP()

BOOL CPPgSMTP::OnInitDialog()
{
	CPropertyPage::OnInitDialog();

	LoadSettings();
	Localize();

	return TRUE;
}

void CPPgSMTP::LoadSettings(void)
{
	m_strSMTPServer = m_pPrefs->GetSMTPServer();
	m_strSMTPName = m_pPrefs->GetSMTPName();
	m_strSMTPFrom = m_pPrefs->GetSMTPFrom();
	m_strSMTPTo = m_pPrefs->GetSMTPTo();
	m_strSMTPUserName = m_pPrefs->GetSMTPUserName();
	m_strSMTPPassword = m_pPrefs->GetSMTPPassword();

	m_bSMTPAuthenticated = m_pPrefs->IsSMTPAuthenticated();
	m_bSMTPInfoEnabled = m_pPrefs->IsSMTPInfoEnabled();
	m_bSMTPWarningEnabled = m_pPrefs->IsSMTPWarningEnabled();
	m_bSMTPMsgInSubjEnabled = m_pPrefs->IsSMTPMsgInSubjEnabled();

	UpdateData(FALSE);

	OnEnChangeSMTPAuthenticated();

	SetModified(FALSE);
}

BOOL CPPgSMTP::OnApply()
{
	if (m_bModified)
	{
		UpdateData(TRUE);

		if (!m_strSMTPServer.IsEmpty())
			m_pPrefs->SetSMTPServer(m_strSMTPServer);
		if (!m_strSMTPName.IsEmpty())
			m_pPrefs->SetSMTPName(m_strSMTPName);
		if (!m_strSMTPFrom.IsEmpty())
			m_pPrefs->SetSMTPFrom(m_strSMTPFrom);
		if (!m_strSMTPTo.IsEmpty())
			m_pPrefs->SetSMTPTo(m_strSMTPTo);
		if (!m_strSMTPUserName.IsEmpty())
			m_pPrefs->SetSMTPUserName(m_strSMTPUserName);
		if (!m_strSMTPPassword.IsEmpty())
			m_pPrefs->SetSMTPPassword(m_strSMTPPassword);

		m_pPrefs->SetSMTPAuthenticated(m_bSMTPAuthenticated);
		m_pPrefs->SetSMTPInfoEnabled(m_bSMTPInfoEnabled);
		m_pPrefs->SetSMTPWarningEnabled(m_bSMTPWarningEnabled);
		m_pPrefs->SetSMTPMsgInSubjEnabled(m_bSMTPMsgInSubjEnabled);

		UpdateData(FALSE);

		SetModified(FALSE);
	}

	return CPropertyPage::OnApply();
}

void CPPgSMTP::Localize(void)
{
	if (::IsWindow(m_hWnd))
	{
		SetWindowText(GetResString(IDS_PW_SMTP));
		GetResString(&m_strSMTPAuthenticationFrame, IDS_AUTHENTICATION);
		GetResString(&m_strSMTPServerDesc, IDS_PW_SERVER);
		GetResString(&m_strSMTPNameDesc, IDS_SW_NAME);
		GetResString(&m_strSMTPFromDesc, IDS_FROM);
		GetResString(&m_strSMTPToDesc, IDS_TO);
		GetResString(&m_strSMTPUserNameDesc, IDS_PROXY_USERNAME);
		GetResString(&m_strSMTPPasswordDesc, IDS_PASSWORD);
		SMTPAuthenticatedCheck.SetWindowText(GetResString(IDS_ENABLED));
		SMTPInfoEnabledCheck.SetWindowText(GetResString(IDS_SMTPMSG_INFO));
		SMTPWarningEnabledCheck.SetWindowText(GetResString(IDS_SMTPMSG_WARNING));
		SMTPMsgInSubjectCheck.SetWindowText(GetResString(IDS_SMTPMSGINSUBJECT));

		UpdateData(FALSE);
	}
}

void CPPgSMTP::OnEnChangeSMTPAuthenticated()
{
	UpdateData(TRUE);

	SMTPUserNameEdit.EnableWindow(m_bSMTPAuthenticated);
	SMTPPasswordEdit.EnableWindow(m_bSMTPAuthenticated);

	SetModified();
}
