// PPgScheduler.cpp : implementation file

#include "stdafx.h"
#include "emule.h"
#include "PPgScheduler.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

// CPPgScheduler dialog

IMPLEMENT_DYNAMIC(CPPgScheduler, CPropertyPage)
CPPgScheduler::CPPgScheduler()
	: CPropertyPage(CPPgScheduler::IDD)
	, schedulerEnabled(FALSE)
	, exceptMonday(FALSE)
	, exceptTuesday(FALSE)
	, exceptWednesday(FALSE)
	, exceptThursday(FALSE)
	, exceptFriday(FALSE)
	, exceptSaturday(FALSE)
	, exceptSunday(FALSE)
	, shift1Down(_T(""))
	, shift1Up(_T(""))
	, shift1Conn(_T(""))
	, shift1Conn5Sec(_T(""))
	, shift2Up(_T(""))
	, shift2Down(_T(""))
	, shift2Conn(_T(""))
	, shift2Conn5Sec(_T(""))
	, schift1Desc(_T(""))
	, schift2Desc(_T(""))
	, kb1Desc(_T(""))
	, kb2Desc(_T(""))
	, timeDesc(_T(""))
	, downDesc(_T(""))
	, upDesc(_T(""))
	, connDesc(_T(""))
	, conn5Desc(_T(""))
	, frmDesc(_T(""))
{
}

CPPgScheduler::~CPPgScheduler()
{
}

void CPPgScheduler::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_SCH_SHIFT1_TIME, shift1TimeCombo);
	DDX_Control(pDX, IDC_SCH_SHIFT2_TIME, shift2TimeCombo);
	DDX_Check(pDX, IDC_SCH_ENABLED, schedulerEnabled);
	DDX_Check(pDX, IDC_SCH_EXCEPT_MON, exceptMonday);
	DDX_Check(pDX, IDC_SCH_EXCEPT_TUE, exceptTuesday);
	DDX_Check(pDX, IDC_SCH_EXCEPT_WED, exceptWednesday);
	DDX_Check(pDX, IDC_SCH_EXCEPT_THU, exceptThursday);
	DDX_Check(pDX, IDC_SCH_EXCEPT_FRI, exceptFriday);
	DDX_Check(pDX, IDC_SCH_EXCEPT_SAT, exceptSaturday);
	DDX_Check(pDX, IDC_SCH_EXCEPT_SUN, exceptSunday);
	DDX_Text(pDX, IDC_SCH_SHIFT1_DOWN, shift1Down);
	DDX_Text(pDX, IDC_SCH_SHIFT1_UP, shift1Up);
	DDX_Text(pDX, IDC_SCH_SHIFT1_CONN, shift1Conn);
	DDX_Text(pDX, IDC_SCH_SHIFT1_5SEC, shift1Conn5Sec);
	DDX_Text(pDX, IDC_SCH_SHIFT2_UP, shift2Up);
	DDX_Text(pDX, IDC_SCH_SHIFT2_DOWN, shift2Down);
	DDX_Text(pDX, IDC_SCH_SHIFT2_CONN, shift2Conn);
	DDX_Text(pDX, IDC_SCH_SHIFT2_5SEC, shift2Conn5Sec);
	DDX_Control(pDX, IDC_SCH_EXCEPT_MON, exceptMondayCheck);
	DDX_Control(pDX, IDC_SCH_EXCEPT_TUE, exceptTuesdayCheck);
	DDX_Control(pDX, IDC_SCH_EXCEPT_WED, exceptWednesdayCheck);
	DDX_Control(pDX, IDC_SCH_EXCEPT_THU, exceptThursdayCheck);
	DDX_Control(pDX, IDC_SCH_EXCEPT_FRI, exceptFridayCheck);
	DDX_Control(pDX, IDC_SCH_EXCEPT_SAT, exceptSaturdayCheck);
	DDX_Control(pDX, IDC_SCH_EXCEPT_SUN, exceptSundayCheck);
	DDX_Control(pDX, IDC_SCH_ENABLED, schedulerEnabledCheck);
	DDX_Control(pDX, IDC_SCH_SHIFT1_DOWN, shift1DownEdit);
	DDX_Control(pDX, IDC_SCH_SHIFT1_UP, shift1UpEdit);
	DDX_Control(pDX, IDC_SCH_SHIFT1_CONN, shift1ConnEdit);
	DDX_Control(pDX, IDC_SCH_SHIFT1_5SEC, shift1Conn5SecEdit);
	DDX_Control(pDX, IDC_SCH_SHIFT2_UP, shift2UpEdit);
	DDX_Control(pDX, IDC_SCH_SHIFT2_DOWN, shift2DownEdit);
	DDX_Control(pDX, IDC_SCH_SHIFT2_CONN, shift2ConnEdit);
	DDX_Control(pDX, IDC_SCH_SHIFT2_5SEC, shift2Conn5SecEdit);
	DDX_Text(pDX, IDC_SCH_SHIFT1, schift1Desc);
	DDX_Text(pDX, IDC_SCH_SHIFT2, schift2Desc);
	DDX_Text(pDX, IDC_SCH_KB1, kb1Desc);
	DDX_Text(pDX, IDC_SCH_KB2, kb2Desc);
	DDX_Text(pDX, IDC_SCH_TIME, timeDesc);
	DDX_Text(pDX, IDC_SCH_DOWN, downDesc);
	DDX_Text(pDX, IDC_SCH_UP, upDesc);
	DDX_Text(pDX, IDC_SCH_CONN, connDesc);
	DDX_Text(pDX, IDC_SCH_5SEC, conn5Desc);
	DDX_Text(pDX, IDC_SCH_FRM, frmDesc);
}

BEGIN_MESSAGE_MAP(CPPgScheduler, CPropertyPage)
	ON_BN_CLICKED(IDC_SCH_ENABLED, OnBnClickedSCHEnabled)
	ON_CBN_SELCHANGE(IDC_SCH_SHIFT1_TIME, OnCbnSelchangeShift1Time)
	ON_CBN_SELCHANGE(IDC_SCH_SHIFT2_TIME, OnCbnSelchangeShift2Time)
	ON_EN_CHANGE(IDC_SCH_SHIFT1_UP, OnSettingsChange)
	ON_EN_CHANGE(IDC_SCH_SHIFT1_DOWN, OnSettingsChange)
	ON_EN_CHANGE(IDC_SCH_SHIFT1_CONN, OnSettingsChange)
	ON_EN_CHANGE(IDC_SCH_SHIFT1_5SEC, OnSettingsChange)
	ON_EN_CHANGE(IDC_SCH_SHIFT2_UP, OnSettingsChange)
	ON_EN_CHANGE(IDC_SCH_SHIFT2_DOWN, OnSettingsChange)
	ON_EN_CHANGE(IDC_SCH_SHIFT2_CONN, OnSettingsChange)
	ON_EN_CHANGE(IDC_SCH_SHIFT2_5SEC, OnSettingsChange)
	ON_BN_CLICKED(IDC_SCH_EXCEPT_MON, OnSettingsChange)
	ON_BN_CLICKED(IDC_SCH_EXCEPT_TUE, OnSettingsChange)
	ON_BN_CLICKED(IDC_SCH_EXCEPT_WED, OnSettingsChange)
	ON_BN_CLICKED(IDC_SCH_EXCEPT_THU, OnSettingsChange)
	ON_BN_CLICKED(IDC_SCH_EXCEPT_FRI, OnSettingsChange)
	ON_BN_CLICKED(IDC_SCH_EXCEPT_SAT, OnSettingsChange)
	ON_BN_CLICKED(IDC_SCH_EXCEPT_SUN, OnSettingsChange)
END_MESSAGE_MAP()

BOOL CPPgScheduler::OnInitDialog()
{
	CPropertyPage::OnInitDialog();

	CString	strTime;
	int		iRc;

	for (uint32 dwInterval = 0; dwInterval < (24 * 3600); dwInterval += 1800)
	{
		strTime.Format(_T("%u:%02u"), dwInterval / 3600, dwInterval % 3600 / 60);
		shift1TimeCombo.SetItemData(iRc = shift1TimeCombo.AddString(strTime), dwInterval);
		if (dwInterval == m_pPrefs->GetSCHShift1())
			shift1TimeCombo.SetCurSel(iRc);
		shift2TimeCombo.SetItemData(iRc = shift2TimeCombo.AddString(strTime), dwInterval);
		if (dwInterval == m_pPrefs->GetSCHShift2())
			shift2TimeCombo.SetCurSel(iRc);
	}

	LoadSettings();
	Localize();

	return TRUE;
}

void CPPgScheduler::LoadSettings(void)
{
	if (::IsWindow(m_hWnd))
	{
		if(m_pPrefs->GetSCHShift1Upload() == UNLIMITED)
			shift1Up = _T("0");
		else
			FractionalRate2String(&shift1Up, m_pPrefs->GetSCHShift1Upload());

		if(m_pPrefs->GetSCHShift1Download() == UNLIMITED)
			shift1Down = _T("0");
		else
			FractionalRate2String(&shift1Down, m_pPrefs->GetSCHShift1Download());
			
		shift1Conn.Format(_T("%d"), m_pPrefs->GetSCHShift1conn());
		shift1Conn5Sec.Format(_T("%d"), m_pPrefs->GetSCHShift15sec());
		
		if(m_pPrefs->GetSCHShift2Upload() == UNLIMITED)
			shift2Up = _T("0");
		else
			FractionalRate2String(&shift2Up, m_pPrefs->GetSCHShift2Upload());

		if(m_pPrefs->GetSCHShift2Download() == UNLIMITED)
			shift2Down = _T("0");
		else
			FractionalRate2String(&shift2Down, m_pPrefs->GetSCHShift2Download());

		shift2Conn.Format(_T("%d"), m_pPrefs->GetSCHShift2conn());
		shift2Conn5Sec.Format(_T("%d"), m_pPrefs->GetSCHShift25sec());

		exceptMonday = m_pPrefs->IsSCHExceptMon();
		exceptTuesday = m_pPrefs->IsSCHExceptTue();
		exceptWednesday = m_pPrefs->IsSCHExceptWed();
		exceptThursday = m_pPrefs->IsSCHExceptThu();
		exceptFriday = m_pPrefs->IsSCHExceptFri();
		exceptSaturday = m_pPrefs->IsSCHExceptSat();
		exceptSunday = m_pPrefs->IsSCHExceptSun();

		schedulerEnabled = m_pPrefs->IsSCHEnabled();

		UpdateData(FALSE);

		OnBnClickedSCHEnabled();

		SetModified(FALSE);
	}
}

BOOL CPPgScheduler::OnApply()
{
	if(m_bModified)
	{
		UpdateData(TRUE);

		uint32	dwVal;

		if(shift1Up.GetLength() != 0)
		{
			dwVal = String2FranctionalRate(shift1Up);
			m_pPrefs->SetSCHShift1Upload((dwVal < 10) ? ((dwVal != 0) ? 10 : UNLIMITED) : dwVal);
		}
		if(shift1Down.GetLength() != 0)
		{
			dwVal = String2FranctionalRate(shift1Down);
			m_pPrefs->SetSCHShift1Download((dwVal < 10) ? ((dwVal != 0) ? 10 : UNLIMITED) : dwVal);
		}
		g_App.m_pUploadQueue->SCHShift1UploadCheck();

		if(shift1Conn.GetLength() != 0)
		{
			int i = _tstoi(shift1Conn);
			m_pPrefs->SetSCHShift1conn((i != 0) ? i : 0xFFFF);
		}
		if(shift1Conn5Sec.GetLength() != 0)
		{
			int i = _tstoi(shift1Conn5Sec);
			m_pPrefs->SetSCHShift15sec((i != 0) ? i : 0xFFFF);
		}

		if(shift2Up.GetLength() != 0)
		{
			dwVal = String2FranctionalRate(shift2Up);
			m_pPrefs->SetSCHShift2Upload((dwVal < 10) ? ((dwVal != 0) ? 10 : UNLIMITED) : dwVal);
		}
		if(shift2Down.GetLength() != 0)
		{
			dwVal = String2FranctionalRate(shift2Down);
			m_pPrefs->SetSCHShift2Download((dwVal < 10) ? ((dwVal != 0) ? 10 : UNLIMITED) : dwVal);
		}
		g_App.m_pUploadQueue->SCHShift2UploadCheck();

		if(shift2Conn.GetLength() != 0)
		{
			int i = _tstoi(shift2Conn);
			m_pPrefs->SetSCHShift2conn((i != 0) ? i : 0xFFFF);
		}
		if(shift2Conn5Sec.GetLength() != 0)
		{
			int i = _tstoi(shift2Conn5Sec);
			m_pPrefs->SetSCHShift25sec((i != 0) ? i : 0xFFFF);
		}

		if (shift1TimeCombo.GetCurSel() != CB_ERR){
			m_pPrefs->SetSCHShift1(shift1TimeCombo.GetItemData(shift1TimeCombo.GetCurSel()));
		}
		if (shift2TimeCombo.GetCurSel() != CB_ERR){
			m_pPrefs->SetSCHShift2(shift2TimeCombo.GetItemData(shift2TimeCombo.GetCurSel()));
		}

		m_pPrefs->SetSCHExceptMon(exceptMonday);
		m_pPrefs->SetSCHExceptTue(exceptTuesday);
		m_pPrefs->SetSCHExceptWed(exceptWednesday);
		m_pPrefs->SetSCHExceptThu(exceptThursday);
		m_pPrefs->SetSCHExceptFri(exceptFriday);
		m_pPrefs->SetSCHExceptSat(exceptSaturday);
		m_pPrefs->SetSCHExceptSun(exceptSunday);

		m_pPrefs->SetSCHEnabled(schedulerEnabled);

		SetModified(FALSE);
	}
	return CPropertyPage::OnApply();
}

void CPPgScheduler::Localize(void)
{
	if(::IsWindow(m_hWnd))
	{
		SetWindowText(GetResString(IDS_PW_SCHEDULER));
		GetResString(&schift1Desc, IDS_SCH_SHIFT1);
		GetResString(&schift2Desc, IDS_SCH_SHIFT2);
		GetResString(&kb1Desc, IDS_KBYTESEC);
		GetResString(&kb2Desc, IDS_KBYTESEC);
		GetResString(&timeDesc, IDS_TIME);
		GetResString(&downDesc, IDS_DOWNLOAD_NOUN);
		GetResString(&upDesc, IDS_UPLOAD_NOUN);
		GetResString(&connDesc, IDS_PW_MAXC);
		GetResString(&conn5Desc, IDS_MAXCON5_TEXT);
		GetResString(&frmDesc, IDS_SCH_EXCEPT);
		exceptMondayCheck.SetWindowText(GetResString(IDS_SCH_EXCEPT_MON));
		exceptTuesdayCheck.SetWindowText(GetResString(IDS_SCH_EXCEPT_TUE));
		exceptWednesdayCheck.SetWindowText(GetResString(IDS_SCH_EXCEPT_WED));
		exceptThursdayCheck.SetWindowText(GetResString(IDS_SCH_EXCEPT_THU));
		exceptFridayCheck.SetWindowText(GetResString(IDS_SCH_EXCEPT_FRI));
		exceptSaturdayCheck.SetWindowText(GetResString(IDS_SCH_EXCEPT_SAT));
		exceptSundayCheck.SetWindowText(GetResString(IDS_SCH_EXCEPT_SUN));
		schedulerEnabledCheck.SetWindowText(GetResString(IDS_ENABLED));

		UpdateData(FALSE);
	}
}

void CPPgScheduler::OnBnClickedSCHEnabled()
{
	UpdateData(TRUE);

	shift1TimeCombo.EnableWindow(schedulerEnabled);
	shift1UpEdit.EnableWindow(schedulerEnabled);
	shift1DownEdit.EnableWindow(schedulerEnabled);
	shift1ConnEdit.EnableWindow(schedulerEnabled);
	shift1Conn5SecEdit.EnableWindow(schedulerEnabled);
	shift2TimeCombo.EnableWindow(schedulerEnabled);
	shift2UpEdit.EnableWindow(schedulerEnabled);
	shift2DownEdit.EnableWindow(schedulerEnabled);
	shift2ConnEdit.EnableWindow(schedulerEnabled);
	shift2Conn5SecEdit.EnableWindow(schedulerEnabled);
	exceptMondayCheck.EnableWindow(schedulerEnabled);
	exceptTuesdayCheck.EnableWindow(schedulerEnabled);
	exceptWednesdayCheck.EnableWindow(schedulerEnabled);
	exceptThursdayCheck.EnableWindow(schedulerEnabled);
	exceptFridayCheck.EnableWindow(schedulerEnabled);
	exceptSaturdayCheck.EnableWindow(schedulerEnabled);
	exceptSundayCheck.EnableWindow(schedulerEnabled);

	SetModified();
}
