//this file is part of eMule
//Copyright (C)2002-2006 Merkur ( strEmail.Format("%s@%s", "devteam", "emule-project.net") / http://www.emule-project.net )
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#include "stdafx.h"
#include "emule.h"
#include "PPgServer.h"
#include "Inputbox.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

IMPLEMENT_DYNAMIC(CPPgServer, CPropertyPage)
CPPgServer::CPPgServer()
	: CPropertyPage(CPPgServer::IDD)
	, removeDead(FALSE)
	, autoServer(FALSE)
	, smartId(FALSE)
	, m_bAddSrvFromServer(FALSE)
	, m_bAddSrvFromClients(FALSE)
	, autoConnect(FALSE)
	, autoConnectStatic(FALSE)
	, reconnect(FALSE)
	, scoreSystem(FALSE)
	, manualServerHighPriority(FALSE)
	, restartWaiting(FALSE)
	, m_bUseAuxPort(FALSE)
{
}

CPPgServer::~CPPgServer()
{
}

void CPPgServer::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	DDX_Check(pDX, IDC_REMOVEDEAD, removeDead);
	DDX_Check(pDX, IDC_AUTOSERVER, autoServer);
	DDX_Check(pDX, IDC_SMARTIDCHECK, smartId);
	DDX_Check(pDX, IDC_UPDATESERVERCONNECT, m_bAddSrvFromServer);
	DDX_Check(pDX, IDC_ADDSRVFROMCLIENTS, m_bAddSrvFromClients);
	DDX_Check(pDX, IDC_RESTARTWAITING, restartWaiting);
	DDX_Check(pDX, IDC_AUTOCONNECT, autoConnect);
	DDX_Check(pDX, IDC_AUTOCONNECTSTATICONLY, autoConnectStatic);
	DDX_Check(pDX, IDC_RECONN, reconnect);
	DDX_Check(pDX, IDC_SCORE, scoreSystem);
	DDX_Check(pDX, IDC_MANUALSERVERHIGHPRIO, manualServerHighPriority);
	DDX_Text(pDX, IDC_SRVCONTIMEOUT, serverConnectTimeout);
	DDX_Text(pDX, IDC_SERVERKEEPALIVE, serverKeepAliveTimeout);
	DDX_Text(pDX, IDC_SERVERRETRIES, serverRetries);
	DDX_Control(pDX, IDC_SRVCONTIMEOUT, serverConnectTimeoutEdit);
	DDX_Control(pDX, IDC_SERVERKEEPALIVE, serverKeepAliveTimeoutEdit);
	DDX_Control(pDX, IDC_SERVERRETRIES, serverRetriesEdit);
	DDX_Text(pDX, IDC_SRVCONTIMEOUT_LBL, serverConTimeoutDesc);
	DDX_Text(pDX, IDC_SERVERKEEPALIVE_LBL, serverKeepAliveTimeoutDesc);
	DDX_Text(pDX, IDC_SRV_SEC, srvSecDesc);
	DDX_Text(pDX, IDC_SRV_MIN, srvMinDesc);
	DDX_Control(pDX, IDC_REMOVEDEAD, removeDeadCheck);
	DDX_Text(pDX, IDC_RETRIES_LBL, retriesDesc);
	DDX_Control(pDX, IDC_AUTOSERVER, autoServerCheck);
	DDX_Control(pDX, IDC_SMARTIDCHECK, smartIdCheck);
	DDX_Control(pDX, IDC_SCORE, scoreCheck);
	DDX_Control(pDX, IDC_RESTARTWAITING, restartWaitingCheck);
	DDX_Control(pDX, IDC_AUTOCONNECT, autoConnectCheck);
	DDX_Control(pDX, IDC_UPDATESERVERCONNECT, m_AddSrvFromServerCheck);
	DDX_Control(pDX, IDC_ADDSRVFROMCLIENTS, m_AddSrvFromClientsCheck);
	DDX_Control(pDX, IDC_RECONN, reconnCheck);
	DDX_Control(pDX, IDC_MANUALSERVERHIGHPRIO, manualSrvHighCheck);
	DDX_Control(pDX, IDC_AUTOCONNECTSTATICONLY, autoConnectStaticCheck);
	DDX_Control(pDX, IDC_ICC_BUTTON, urlsButton);
	DDX_Control(pDX, IDC_USE_AUX_PORT_CHECKBOX, m_btnUseAuxPortCheck);
	DDX_Check(pDX, IDC_USE_AUX_PORT_CHECKBOX, m_bUseAuxPort);
}

BEGIN_MESSAGE_MAP(CPPgServer, CPropertyPage)
	ON_EN_CHANGE(IDC_SRVCONTIMEOUT, OnSettingsChange)
	ON_EN_CHANGE(IDC_SERVERRETRIES, OnSettingsChange)
	ON_EN_CHANGE(IDC_SERVERKEEPALIVE, OnSettingsChange)
	ON_BN_CLICKED(IDC_AUTOSERVER, OnSettingsChange)
	ON_BN_CLICKED(IDC_UPDATESERVERCONNECT, OnSettingsChange)
	ON_BN_CLICKED(IDC_ADDSRVFROMCLIENTS, OnSettingsChange)
	ON_BN_CLICKED(IDC_SCORE, OnSettingsChange)
	ON_BN_CLICKED(IDC_REMOVEDEAD, OnBnClickedRemovedead)
	ON_BN_CLICKED(IDC_RESTARTWAITING, OnSettingsChange)
	ON_BN_CLICKED(IDC_SMARTIDCHECK, OnSettingsChange)
	ON_BN_CLICKED(IDC_AUTOCONNECT, OnSettingsChange)
	ON_BN_CLICKED(IDC_RECONN, OnSettingsChange)
	ON_BN_CLICKED(IDC_AUTOCONNECTSTATICONLY, OnSettingsChange)
	ON_BN_CLICKED(IDC_MANUALSERVERHIGHPRIO, OnSettingsChange)
	ON_BN_CLICKED(IDC_ICC_BUTTON, OnSetURLsForICC)
	ON_BN_CLICKED(IDC_USE_AUX_PORT_CHECKBOX, OnSettingsChange)
END_MESSAGE_MAP()

// CPPgServer message handlers

BOOL CPPgServer::OnInitDialog()
{
	CPropertyPage::OnInitDialog();

	serverKeepAliveTimeoutEdit.SetLimitText(2);
	serverKeepAliveTimeoutEdit.SetLimitText(2);
	serverRetriesEdit.SetLimitText(2);

	LoadSettings();
	Localize();

	return TRUE;
}

void CPPgServer::LoadSettings(void)
{
	serverConnectTimeout.Format(_T("%u"), m_pPrefs->SrvConTimeout() / 1000);
	serverRetries.Format(_T("%u"), m_pPrefs->GetDeadserverRetries());
	serverKeepAliveTimeout.Format(_T("%u"), m_pPrefs->GetServerKeepAliveTimeout() / 60000);

	manualServerHighPriority = m_pPrefs->GetManualHighPrio();
	smartId = m_pPrefs->GetSmartIdCheck();
	removeDead = m_pPrefs->DeadServer();
	autoServer = m_pPrefs->AutoServerlist();
	m_bAddSrvFromServer = m_pPrefs->GetAddServersFromServer();
	m_bAddSrvFromClients = m_pPrefs->GetAddServersFromClients();
	scoreSystem = m_pPrefs->GetUseServerPriorities();
	restartWaiting = m_pPrefs->RestartWaiting();
	reconnect = m_pPrefs->Reconnect();
	autoConnect = m_pPrefs->DoAutoConnect();
	autoConnectStatic = m_pPrefs->AutoConnectStaticOnly();

	m_bUseAuxPort = m_pPrefs->IsServerAuxPortUsed();

	UpdateData(FALSE);
	OnBnClickedRemovedead();
	SetModified(FALSE);
}

BOOL CPPgServer::OnApply()
{
	if(m_bModified)
	{
		UpdateData(TRUE);

		m_pPrefs->SetDeadServer(removeDead);
		m_pPrefs->SetSmartIdCheck(smartId);

		int	iVal = _tstoi(serverConnectTimeout);
		if (iVal < 10)
			iVal = 10;
		else if(iVal > 60)
			iVal = 60;

		m_pPrefs->SetSrvConTimeout(iVal * 1000);
		serverConnectTimeout.Format(_T("%u"), m_pPrefs->SrvConTimeout() / 1000);

		iVal = _tstoi(serverRetries);
		if (iVal <= 0)
		{
			iVal = m_pPrefs->GetDeadserverRetries();
			serverRetries.Format(_T("%u"), iVal);
		}
		m_pPrefs->SetDeadserverRetries(iVal);

		m_pPrefs->SetServerKeepAliveTimeout(_tstoi(serverKeepAliveTimeout) * 60000);

		m_pPrefs->SetUseServerPriorities(scoreSystem);
		m_pPrefs->SetAutoServerlist(autoServer);
		m_pPrefs->SetAddServersFromServer(m_bAddSrvFromServer);
		m_pPrefs->SetAddServersFromClients(m_bAddSrvFromClients);
		m_pPrefs->SetRestartWaiting(restartWaiting);
		m_pPrefs->SetAutoConnect(autoConnect);
		m_pPrefs->SetReconnect(reconnect);
		m_pPrefs->SetManualHighPrio(manualServerHighPriority);
		m_pPrefs->SetAutoConnectStaticOnly(autoConnectStatic);
		m_pPrefs->SetServerAuxPortUsed(m_bUseAuxPort);

		SetModified(FALSE);
	}

	return CPropertyPage::OnApply();
}

void CPPgServer::Localize(void)
{
	if(::IsWindow(m_hWnd))
	{
		SetWindowText(GetResString(IDS_PW_SERVER));

		GetResString(&serverConTimeoutDesc, IDS_SRVCONTIMEOUT_LBL);
		GetResString(&srvSecDesc, IDS_SECS);
		removeDeadCheck.SetWindowText(GetResString(IDS_PW_RDEAD));
		GetResString(&retriesDesc, IDS_PW_RETRIES);
		GetResString(&serverKeepAliveTimeoutDesc, IDS_PW_KEEPALIVE);
		GetResString(&srvMinDesc, IDS_MINS);
		m_AddSrvFromServerCheck.SetWindowText(GetResString(IDS_PW_USC));
		m_AddSrvFromClientsCheck.SetWindowText(GetResString(IDS_ADDSRVFROMCLIENTS));
		autoServerCheck.SetWindowText(GetResString(IDS_PW_USS));
		scoreCheck.SetWindowText(GetResString(IDS_PW_SCORE));
		restartWaitingCheck.SetWindowText(GetResString(IDS_RESTARTWAITING));
		smartIdCheck.SetWindowText(GetResString(IDS_SMARTLOWIDCHECK));
		autoConnectCheck.SetWindowText(GetResString(IDS_PW_AUTOCON));
		reconnCheck.SetWindowText(GetResString(IDS_PW_RECON));
		manualSrvHighCheck.SetWindowText(GetResString(IDS_MANUALSERVERHIGHPRIO));
		autoConnectStaticCheck.SetWindowText(GetResString(IDS_PW_AUTOCONNECTSTATICONLY));
		urlsButton.SetWindowText(GetResString(IDS_ICC_BUTTON));
		m_btnUseAuxPortCheck.SetWindowText(GetResString(IDS_USE_AUX_PORT_CHECKBOX));

		UpdateData(FALSE);
	}
}

void CPPgServer::OnBnClickedRemovedead()
{
	UpdateData(TRUE);
	serverRetriesEdit.EnableWindow(removeDead);

	SetModified();
}

void CPPgServer::OnSetURLsForICC()
{
	InputBox inputbox(GetResString(IDS_ICC_INPUTBOX), g_App.m_pPrefs->GetURLsForICC());

	inputbox.DoModal();
	if (!inputbox.WasCancelled())
	{
		g_App.m_pPrefs->SetURLsForICC(inputbox.GetInput());
		g_App.InitURLs();
		SetModified();
	}
}
